#define STRONGARM 1

#ifndef STRONGARM

/* xscale */

#define MEM_START	0xa0000000

/* Memory in MByte */
#define MEM_SIZE	64

#define KERNELCOPY	0xa0a00000
//#define KERNELCOPY	0xa0800000  

#define INITRD		0xa0d00000
#define INITRD_TAG	ATAG_INITRD2

/* Interrupt controller */
#define ICIP		0x40D00000

#define UARTBASE	0x40100000
#define UARTDATA	0x00
#define UARTSTATUS	0x14
#define UARTTXRDY	5
#define UARTTXBIT	0

/* Not used */
#define BOOTIMG		0xa0008000

/* MACH_TYPE_H1900 */
#define MACH_TYPE_JORNADA720           48
#define MACH_TYPE	48

#else

/* strongarm */

#define MEM_START	0xc0000000

/* Memory in MByte */
#define MEM_SIZE	32

#define KERNELCOPY	0xc0a00000

#define INITRD		0xc0d00000
#define INITRD_TAG	ATAG_INITRD

/* Interrupt controller */
#define ICIP		0x90050000

#define UARTBASE	0x80030000
#define UARTDATA	0x14
#define UARTSTATUS	0x20
#define UARTTXRDY	2
#define UARTTXBIT	0

/* Not used */
#define BOOTIMG		0xc0008000

/* MACH_TYPE_H3600 */
//#define MACH_TYPE	22

/* MACH_TYPE_H3800 */
//#define MACH_TYPE	137

/* MACH_TYPE_XDA */
#define MACH_TYPE_JORNADA720           48
#define MACH_TYPE	48

#endif


